# coding=UTF-8
'''
Created on Mar 31, 2010

@author: ivan
'''
from pluginutils.parseutils import BaseScraper
from pluginutils.parseutils import read_page, XML, HTML
import urlparse
import re, traceback, sys
try:
    import xbmc
    _=xbmc.getLocalizedString
except:
    _=lambda x:x

CATEGORIES=((_(30110), 'http://www.ceskatelevize.cz/ivysilani/ajax/bottom.php', '', {'URL':'/ivysilani/nejnovejsi/'}),
            (_(30120), 'http://www.ceskatelevize.cz/ivysilani/ajax/bottom.php', '', {'URL':'/ivysilani/nejsledovanejsi/'}),
            )

CAT_ALPHA=((_(30130), 'http://www.ceskatelevize.cz/ivysilani/podle-abecedy/', '', {'cat_id':'programmeAlphabet'}),
           (_(30140), 'http://www.ceskatelevize.cz/ivysilani/podle-abecedy/', '', {'cat_id':'programmeGenre'}))

TITLE_LIST_URL='http://www.ceskatelevize.cz/ivysilani/ajax/programmeData.php'

CAT_DATE=(_(30150), 'http://www.ceskatelevize.cz/ivysilani/%s/', '')

STATIONS=(('CT1',''), ('CT2', ''), ('CT24', ''), ('CT4', ''))


class SearchScraper(BaseScraper):
    def get_items(self):
        pass
    def next(self):
        pass
    def next_page(self):
        pass

class TitleListScraper(BaseScraper):
    def __init__(self, url, page=None, data=None):
        self.url=url
        path='/'+urlparse.urlsplit(url)[2]+'dalsi-casti'
        self.doc=read_page(TITLE_LIST_URL, HTML, {'URL':path})
        self.page=page
        self.finished=False
        self.one_only=False
        if self.doc.find('div', id='discussion'):
            #We do not have more titles, grab the main one
            self.doc=read_page(self.url)
            self.one_only=True
        else:
            self.items=iter(self.get_items()) 
        
    def get_items(self):
        return self.doc.find('div', id='programmeContentBlock').findAll('li')
    DATE_RE=re.compile(r'^\d{1,2}\.\s*\d{1,2}\.\s*\d{4}$')
    def next(self):
        if self.finished:
            raise StopIteration()
        if self.one_only:
            info=self.doc.find('div', id='programmeInfo').div
            header_elem=info.h2
            try:
                title=header_elem.findNextSibling('p').contents[0].string.strip()
            except Exception, e:
                title=''
                pass
            full_title=header_elem.text
            if title: full_title+= ' - '+title
            self.finished=True
            return full_title, self.url, '', None
        item=self.items.next()
        img_elem=item.find('img')
        link=img_elem.parent
        if not link or not link.has_key('href'):
            #item is not available
            return self.next()
        url=urlparse.urljoin(self.url, link['href'])
        img_src=img_elem['src']
        header_elem=item.h3
        header=header_elem.text
        title_elem=header_elem.findNext('p')
        if title_elem and not title_elem.get('class')=='addPlaylist':
            title=title_elem.text
        else:
            title=''
            
        if  self.DATE_RE.match(header):
            date=header
            if title:
                full_title= '%s (%s)' %(title, date)
            else:
                full_title=header
        elif self.DATE_RE.match(title):
            date=title
            full_title= '%s (%s)' %(header, date)
            
        else:
            date=''
            if title:
                full_title= '%s - %s' %(header, title)
            else:
                full_title=header
            
            
        date=date.replace(' ', '')
        additional_info={"Date": date,}
        return full_title, url, img_src, additional_info
    
    def next_page(self):
        if self.one_only:
            return None
        pager =self.doc.find('div', 'pagingContent')
        if not pager:
            return None
        next_page=None
        last_page=None
        next_url=None
        pages=pager.findAll('a', 'detailProgrammePaging')
        for p in pages:
            if p.img['alt']=='>':
                next_page=p['title']
                next_url=p['href']
            elif p.img['alt']=='>>':
                last_page=p['title']
                
        if not next_url:
            return None
        return next_page, urlparse.urljoin(self.url,next_url),last_page
                
        
        
        
class TopCategoryScraper(BaseScraper):
    
    def get_items(self):
        return self.doc.find('div', id='topBackground').findAll('div', 'item')
    date_plot_re=re.compile(r'^(\d{1,2}\.\s*\d{1,2}\.\s*\d{4})\s*:?\s*(.+)?$', re.UNICODE)
    def next(self):
        item=self.items.next()
        title_elem=item.find('p', 'title').a
        title=title_elem.text
        path=title_elem['href']
        img_src=item.find('div', 'foto').img['src']
        try:
            dp_elem=item.find('p', 'title').findNextSibling('p')
            text=unicode(dp_elem.string.strip())
            m=self.date_plot_re.match(text)
            date=m.group(1).replace(' ','')
            plot=m.group(2) or ''
        except:
            date, plot='', ''
        if date:
            title= "%s (%s)"% (title, date)
        additional_info={"Date": date,'Plot':plot, 'Plotoutline':plot}
        #{ "Title": title, "Director": director, "Duration": runtime, "Plot": plot, "Rating": rating, "Genre": genre, "Count": count, "Date": date } )
        return title, urlparse.urljoin(self.url, path), img_src, additional_info
        
    def next_page(self):
        return False
    
quality_param='?streamtype=WM%d'

def scrap_video(url, quality):
    url=url+quality_param%(int(quality)+1)
    print url
    doc=read_page(url)
    #print doc
    player=doc.find('object', id='programmeObject')
    if not player:
        return None
    asx_url=player['data']
    asx_doc=read_page(asx_url,XML)
    print asx_doc.prettify()
    refs= [r.ref for r in asx_doc.findAll('entry', clientskip=None)]
    refs=[i['href'] for i in refs]
    if not refs:
        refs=[r.ref for r in asx_doc.findAll('entry')]
        refs=[i['href'] for i in refs]
        nr=[]
        for r in refs:
            if  r.find('CONTENT_NAME=ad&')==-1:
                nr.append(r)
        refs=nr
        
            
    if len(refs)>1:
        print "ISSUE: Multiple main videos, playing first one"
    info= doc.find('div', id='programmeInfo').find('div', 'line')
    title=info.h2.text
    try: 
        plot=info.findAll('p')[1].text
    except Exception,e: 
        plot=''
        #traceback.print_exc(file=sys.stdout)
    #additional_info={"Duration": length, "Date": date,'Plot':plot, 'Plotoutline':plot_outline, 'Rating':rating}
    additional_info={'Plot':plot, 'Plotoutline':plot}
    return refs[-1], title, additional_info

def scrap_alphabet(url, container_id='programmeAlphabet'):
    doc=read_page(url)
    items=doc.find('ul', id=container_id).findAll('li', {'class': lambda x: x!='all'})
    for i in items:
        link=i.a
        yield link.text, urlparse.urljoin(url,link['href']), ""
        
def scrap_titles(url):
    doc=read_page(url)
    items=doc.find('div', id='programmeAlphabetContent').findAll('li')
    for i in items:
        link=i.a
        title=link.get('title') or ''
        yield {'name':link.text, 'url':urlparse.urljoin(url, link['href']), 
               'additional_info': {'Plot':title, 'Plotoutline':title}} 
        
import datetime   
  
def list_dates(date=None):
    if not date:
        date=datetime.date.today()
    month=date.month
    date=date.replace(day=1)
    while date.month==month:
        date_str=date.strftime('%d.%m.%Y')
        yield {'name':date.strftime('%a %d.%m.%Y'), 'url':CAT_DATE[1]%date_str,}
        date=date+datetime.timedelta(days=1)
        
        
class StationScraper(BaseScraper):
    def __init__(self, url, page=None, data=None):
        if not page:
            raise ValueError('Station name must be specified')
        self.station=page
        BaseScraper.__init__(self,url)
    def get_items(self):
        stations=[i[0] for i in STATIONS]
        index=stations.index(self.station)
        container= self.doc.find('div', id='programDate').findAll('div', 'program-column')[index]
        return container.findAll('li')
    
    def next(self):
        item=self.items.next()
        time=item.find('span', 'time').text
        title_elem=item.find('span', 'title')
        if not title_elem:
            return self.next()
        subtitle=title_elem.findNextSibling('span', 'hrefGrayLight')
        if subtitle:
            subtitle=subtitle.text
        
        title_elem=title_elem.a
        if not title_elem:
            return self.next()
        title=title_elem.text
        url=title_elem['href']
        if subtitle:
            title="%s - %s - %s"%(time, title, subtitle)
        else:
            title="%s - %s"%(time, title)
        return title, urlparse.urljoin(self.url,url), '', {}
        
        
    

def prev_month(date):
    month=date.month
    year=date.year
    month=month-1
    if month<1:
        month=12
        year-=1
    return date.replace(month=month, year=year)   